#!/usr/bin/python

#This script generates a pdf-file of a checkerboard marker
#Usage: ./markers <size in cm> <width x height>
#
#Example: ./markers 1.0 4x6 
#         -> generates a pdf with 4x6 squares with a width of 1cm

import sys
import os
import Image,ImageDraw,ImageFont,ImageChops

print sys.argv[1]
print sys.argv[2]

s = float(sys.argv[1])
for n in sys.argv[2:]:
  w,h = n.split("x")
  w = int(w)
  h = int(h)
  img = Image.new("L",(w+1,h+1),1)
  draw = ImageDraw.Draw(img)
  for x in range(w+1):
    for y in range(h+1):
      c=(x+y)%2
     # print c
      draw.point( (x,y), c*255 )
  img.save("%s.png"%n,"PNG")

with open('markers.tex', 'w') as f:
  f.write("""
	\\documentclass[a4paper,10pt]{article}\n
	\\usepackage{graphicx}\n
	\\usepackage{a4wide}\n
	\\usepackage{color}\n
	\\begin{document}\n
	\\tiny
	\\definecolor{gray}{rgb}{0.5,0.5,0.5}
	\\color{gray}
""")
	
  for n in sys.argv[2:]:
    w,h = n.split("x")
    w = int(w)
    h = int(h)
    f.write("\\indent\\hspace{-2cm}\\includegraphics[width=%dcm]{%s}\\newline$ $\\newline %s\\vspace{2cm}\n\\newline \\newline "%((w+1)*s,n,n.replace("_","-")))
	
  f.write("\\end{document}\n")

os.system("pdflatex markers")
os.system("evince markers.pdf")


