#!/usr/bin/env python

# Script to synchronize the timings in a recorded bagfile, so that it can be 
# played back in sync with the timestamps of the recorded data. Useful for 
# fixing a "jerky" or asynchronuous visalization in RViz e.g. when recorded 
# over wireless

# See http://code.ros.org/lurker/message/20100901.154936.67720d20.en.html#ros-users
# and http://www.ros.org/wiki/rosbag/Cookbook

import roslib; roslib.load_manifest('rosbag')
import sys, rosbag
outbag = rosbag.Bag(sys.argv[2], 'w')
try:
    for topic, msg, t in rosbag.Bag(sys.argv[1]).read_messages():
        if topic == "/tf":
            outbag.write(topic, msg, msg.transforms[0].header.stamp)
            
        elif not topic == "/rosout":
            outbag.write(topic, msg, msg.header.stamp if msg._has_header else t)
finally:
    outbag.close()
                
